#property indicator_separate_window
#property indicator_buffers 2
#property indicator_minimum 0

int Look_Back;
extern int Label_X   = 630;
extern color Up_Color = clrSeaGreen;
extern int   UpBar_Width = 3;
extern color Down_Color = clrCrimson;
extern int   DwnBar_Width = 2;
extern color VLine_UpColor = clrGreen;
extern color VLine_DwnColor = clrCrimson;

double UpTicks[];
double DownTicks[];
double Sum_Down=0;
double Sum_Up=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
IndicatorShortName("TicksSeparateVolume("+Symbol()+")");

SetIndexBuffer(0,UpTicks);
SetIndexBuffer(1,DownTicks);

SetIndexStyle(0,DRAW_HISTOGRAM,0,UpBar_Width,Up_Color);
SetIndexStyle(1,DRAW_HISTOGRAM,0,DwnBar_Width,Down_Color);

SetIndexLabel(0,"UpTicks");
SetIndexLabel(1,"DownTicks");

return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{

ObjectDelete("UpTicks1");
ObjectDelete("DownTicks1");
ObjectDelete("UpTicks2");
ObjectDelete("DownTicks2");

Comment("");

return(0);
}
//+------------------------------------------------------------------+
//| Ticks Volume Indicator |
//+------------------------------------------------------------------+
int start()
{

ObjectDelete("UpTicks1");
ObjectDelete("DownTicks1");
ObjectDelete("UpTicks2");
ObjectDelete("DownTicks2");

int i,counted_bars=IndicatorCounted();
//---- check for possible errors
if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
if(counted_bars>0) counted_bars--;
int limit=Bars-counted_bars;


//----
for(i=0; i<limit; i++)
{
UpTicks[i]=(Volume[i]+(Close[i]-Open[i])/Point)/2;
DownTicks[i]=Volume[i]-UpTicks[i];
}

  Sum_Up = 0 ;   //!!!!!!!
  Sum_Down = 0 ; // !!!!!!
  Look_Back = 0; 
   if(ObjectFind(0,"LookBackLine")==0)
    {
    datetime time=ObjectGetInteger(0,"LookBackLine",OBJPROP_TIME);
    Look_Back=iBarShift(NULL,0,time,true);
    } else Look_Back=5;
    
   for(i=0; i<Look_Back; i++)
     {      
      Sum_Up = Sum_Up + UpTicks[i];
      Sum_Down = Sum_Down + DownTicks[i];
      if(Sum_Down<Sum_Up)
      ObjectSetInteger(0,"LookBackLine",OBJPROP_COLOR,VLine_UpColor);
      if(Sum_Down>Sum_Up)
      ObjectSetInteger(0,"LookBackLine",OBJPROP_COLOR,VLine_DwnColor);
      
     }  
     
     ChartRedraw();
     
string BV="BUYERS (GREEN VOLUME): "+DoubleToStr(UpTicks[0],0)+"";
string SV="SELLERS (RED VOLUME): "+DoubleToStr(DownTicks[0],0)+"";


ObjectCreate("UpTicks2", OBJ_LABEL, WindowFind("TicksSeparateVolume("+Symbol()+")"), 0, 0);
ObjectSetText("UpTicks2","Sum Up("+Look_Back+"): "+DoubleToStr(Sum_Up,0), 10, "Tahoma" ,LimeGreen);
ObjectSet("UpTicks2", OBJPROP_CORNER, 0);
ObjectSet("UpTicks2", OBJPROP_XDISTANCE, Label_X);
ObjectSet("UpTicks2", OBJPROP_YDISTANCE, 22);

ObjectCreate("DownTicks2", OBJ_LABEL, WindowFind("TicksSeparateVolume("+Symbol()+")"), 0, 0);
ObjectSetText("DownTicks2","Sum Down("+Look_Back+"): "+DoubleToStr(Sum_Down,0), 10, "Tahoma" ,Red);
ObjectSet("DownTicks2", OBJPROP_CORNER, 0);
ObjectSet("DownTicks2", OBJPROP_XDISTANCE, Label_X);
ObjectSet("DownTicks2", OBJPROP_YDISTANCE, 42);

//----
return(0);
}
//+------------------------------------------------------------------+

